// *** IDic Windows CE ***
// Version 1.2
// Franois PESSAUX June 2001
// This program is freeware.
// Use its sources as you whant provided that you leave this copyright unchanged
// and that you drop a small word telling that I'm the author of these sources.
// Thank's a lot.
//   --Francois

#include "stdafx.h"
#include "resource.h"



/*
	NOTE: this code is really not modular ! The anim stuff is pretty hard coded.
	To be clean, all this should be view as a module encapsulating animations to
	allow re-entrant en multiple animation. Call this "object-oriented" stuff if
	you want, I prefer "modular-oriented" stuff :-)))
	As long as we only need 1 animation, this is sufficient. Anyway, it's really
	not difficult to generalize this code to make something cleaner if needed !!!
*/




void CALLBACK SearchAnimTimerProc (HWND hwnd, UINT uMsg, UINT idEvent, DWORD dwTime)
{
	HDC hdc ;

	hdc = GetWindowDC (hwnd) ;
	// Hard code centering the animation in the main window. Beuh !!!
	TransparentImage (hdc, 32, MENU_HEIGHT, FRAME_WIDTH, FRAME_HEIGHT,
		(HANDLE) search_anim.frames[search_anim.current_frame],
		0, 0, FRAME_WIDTH, FRAME_HEIGHT, RGB (255,0,0)) ;
	ReleaseDC (hwnd, hdc) ;
	UpdateWindow (hwnd) ;
	search_anim.current_frame = (search_anim.current_frame + 1) % SEARCH_FRAME_COUNT ;
}




// Modal dialog box handler.
LRESULT CALLBACK AnimDialogHandler (HWND w_handle, UINT message,
									  WPARAM w_param, LPARAM l_param)
{
	int wm_id, wm_event ;
	
	wm_id    = LOWORD (w_param) ;
	wm_event = HIWORD (w_param) ;
	
	switch (message) {
		case WM_INITDIALOG:
			// Tells that we fully handled this message.
			search_anim.current_frame = 0 ;
			search_anim.owner_window = w_handle ;
			SetTimer (w_handle, SEARCH_TIMER_ID, SEARCH_TIMER_AMOUNT, SearchAnimTimerProc) ;
			// Finally update the dialog window.
			ShowWindow (w_handle, SW_SHOW) ;
			UpdateWindow (w_handle) ;
			return (TRUE) ;
			break ;													// End of WM_INITDIALOG

		case WM_COMMAND:
			switch (wm_id) {
				case IDB_ANIM_ABORT:
					// Tells that we fully handled this message.
					PostMessage (w_handle, WM_CLOSE, (WPARAM) 0, (LPARAM) 0) ;
					return (TRUE) ;
					break ;											// End of IDB_ANIM_ABORT
				}															// End of switch (wm_id)
			break ;													// End of WM_COMMAND

		case WM_CLOSE:
			KillTimer (w_handle, SEARCH_TIMER_ID) ;
			// Close the modal dialog.
			EndDialog (w_handle, TRUE) ;
			search_anim.owner_window = NULL ;
			return (TRUE) ;
			break ;
		}																	// End of switch (message)

	// Tells that we did not handle the message
	// Force default handling by the system (because we're
	// in the case of a dialog handler). Calling DefWindowProc is only the
	// protocol for window handlers
  return (FALSE) ;
}




void StartSearchAnim ()
{
	DialogBox (app_instance_handle, MAKEINTRESOURCE (IDD_DIALOG_SEARCHANIM),
		main_window_hd,	(DLGPROC) AnimDialogHandler) ;
}



void StopSearchAnim ()
{
	PostMessage (search_anim.owner_window, WM_CLOSE, (WPARAM) 0, (LPARAM) 0) ;
}	



void InitSearchAnim ()
{
	int i ;

	search_anim.current_frame = 0 ;
	search_anim.owner_window = NULL ;
	for (i=0; i<SEARCH_FRAME_COUNT; i++) {
		search_anim.frames[i] = (HBITMAP) LoadBitmap (app_instance_handle,
			MAKEINTRESOURCE (IDB_BITMAP1 + i)) ;
		}																	// End of for (i=0; i<SEARCH_FRAME_COUNT; i++)
}



void ReleaseSearchAnim ()
{
	int i ;

	// First, stop the animation.
	StopSearchAnim () ;
	// Then free the bitmaps.
	for (i=0; i<SEARCH_FRAME_COUNT; i++) {
		if (search_anim.frames[i]) DeleteObject (search_anim.frames[i]) ;
		}																	// End of for (i=0; i<SEARCH_FRAME_COUNT; i++)
}
