// *** IDic Windows CE ***
// Version 1.2
// Franois PESSAUX June 2001
// This program is freeware.
// Use its sources as you whant provided that you leave this copyright unchanged
// and that you drop a small word telling that I'm the author of these sources.
// Thank's a lot.
//   --Francois

#include "stdafx.h"
#include "resource.h"


const TBBUTTON cbar_buttons_def[] = {
//  BitmapIndex       Command   State            Style       UserData String
	{3,    IDC_BUTTON_OPENDIC,  TBSTATE_ENABLED, TBSTYLE_BUTTON,    0,   0},
	{0,    0,										TBSTATE_ENABLED, TBSTYLE_SEP,				0,   0},
  {0,    IDC_BUTTON_EXIST,		TBSTATE_ENABLED, TBSTYLE_BUTTON,    0,   0},
  {1,    IDC_BUTTON_SUGGEST,  TBSTATE_ENABLED, TBSTYLE_BUTTON,    0,   0},
  {2,    IDC_BUTTON_CHEAT,    TBSTATE_ENABLED, TBSTYLE_BUTTON,    0,   0},
	{0,    0,										TBSTATE_ENABLED, TBSTYLE_SEP,				0,   0},
	{4,    IDC_BUTTON_CASE,			TBSTATE_ENABLED|TBSTATE_CHECKED, TBSTYLE_CHECK,   0,   0},
	{0,    0,										TBSTATE_ENABLED, TBSTYLE_SEP,				0,   0},
  {5 + STD_COPY,  IDC_BUTTON_COPY,	TBSTATE_ENABLED, TBSTYLE_BUTTON,  0,   0},
	{5 + STD_PASTE, IDC_BUTTON_PASTE,	TBSTATE_ENABLED, TBSTYLE_BUTTON,  0,   0}
} ;


const LPTSTR cbar_tooltips_def[] = {
	TEXT("Load dictionary"),
	TEXT("Check existence"),
	TEXT("Close spellings"),
	TEXT("Match pattern"),
	TEXT("Switch case sensitivity"),
	TEXT("Copy to clipboard"),
	TEXT("Paste from clipboard")
} ;




// Modeless dialog handler procedure.
BOOL CALLBACK MainDlgHandler (HWND w_handle, UINT message, WPARAM w_param,
															LPARAM l_param)
{
	int wm_id, wm_event ;
	
	wm_id    = LOWORD (w_param) ;
  wm_event = HIWORD (w_param) ;

  switch (message) {
		case WM_COMMAND:
			switch (wm_id) {
			case IDC_EDIT_MAIN:
				switch (wm_event) {
					case EN_SETFOCUS:
						SipShowIM (SIPF_ON) ;
						// Force the system to finish handling the message.
						return (FALSE) ;
						break ;										// End of EN_SETFOCUS

					case EN_KILLFOCUS:
						SipShowIM (SIPF_OFF) ;
						// Force the system to finish handling the message.
						return (FALSE) ;
						break ;										// End of EN_KILLFOCUS
				}															// End of switch (wm_event)
				break ;												// End of IDC_EDIT_MAIN
			}																// End of switch (wm_id)
		break ;														// End of WM_COMMAND
	}																		// End of switch (message)

	// Force default handling by the system (because we're
	// in the case of a dialog handler). Calling DefWindowProc is only the
	// protocol for window handlers
	return (FALSE) ;
}






void UserInterfaceOnOff (BOOL flag)
{

	// Set buttons, entry and so on state according to the resquest:
	// TRUE means ENABLED, FALSE means DISABLED.
	SendMessage (cbar_handle, TB_ENABLEBUTTON, IDC_BUTTON_COPY, (LPARAM) MAKELONG (flag, 0)) ;
	SendMessage (cbar_handle, TB_ENABLEBUTTON, IDC_BUTTON_PASTE, (LPARAM) MAKELONG (flag, 0)) ;
	SendMessage (cbar_handle, TB_ENABLEBUTTON, IDC_BUTTON_EXIST, (LPARAM) MAKELONG (flag, 0)) ;
	SendMessage (cbar_handle, TB_ENABLEBUTTON, IDC_BUTTON_SUGGEST, (LPARAM) MAKELONG (flag, 0)) ;
	SendMessage (cbar_handle, TB_ENABLEBUTTON, IDC_BUTTON_CHEAT, (LPARAM) MAKELONG (flag, 0)) ;
	SendMessage (cbar_handle, TB_ENABLEBUTTON, IDC_BUTTON_OPENDIC, (LPARAM) MAKELONG (flag, 0)) ;
	SendMessage (cbar_handle, TB_ENABLEBUTTON, IDC_BUTTON_CASE, (LPARAM) MAKELONG (flag, 0)) ;
	EnableWindow (main_edit_hd, flag) ;
}



LRESULT CALLBACK MainWindowHandler (HWND w_handle, UINT message, WPARAM w_param,
																		LPARAM l_param)
{
  int wm_id, wm_event ;

  wm_id    = LOWORD (w_param) ;
  wm_event = HIWORD (w_param) ;

  switch (message) {
		case WM_CREATE:
			main_dialog_hd = CreateDialog (app_instance_handle,
				MAKEINTRESOURCE(IDD_DIALOG_MAIN), w_handle, (DLGPROC) MainDlgHandler) ;
			// Init global references on the "edit-listbox" used to display results
			// and on the edit used to get the user's request
			status_static_hd = GetDlgItem (main_dialog_hd, IDC_STATIC_STATUS) ;
			result_edit_hd = GetDlgItem (main_dialog_hd, IDC_LIST_RESULT) ;
			result_frame_hd = GetDlgItem (main_dialog_hd, IDC_STATIC_RESULT_FRAME) ;
			main_edit_hd = GetDlgItem (main_dialog_hd, IDC_EDIT_MAIN) ;
			// Add the command bar.
			cbar_handle = CommandBar_Create (app_instance_handle, w_handle, 1000) ;
			CommandBar_AddBitmap (cbar_handle, app_instance_handle, IDB_BITMAP_CBAR_UP, 5, 0, 0) ;
			CommandBar_AddBitmap (cbar_handle, HINST_COMMCTRL, IDB_STD_SMALL_COLOR, 2, 0, 0) ;
			CommandBar_AddButtons (cbar_handle, 10, cbar_buttons_def) ;
			CommandBar_AddToolTips (cbar_handle, 7, cbar_tooltips_def) ;
			CommandBar_AddAdornments (cbar_handle, CMDBAR_HELP, NULL) ;
			// Finally, show the whole window.
			SetFocus (main_edit_hd) ;
			MoveWindow (main_dialog_hd, 0, CommandBar_Height (cbar_handle), 240, 300, FALSE) ;
			ShowWindow (main_dialog_hd, SW_SHOW) ;
			UpdateWindow (main_dialog_hd) ;
			return (0) ;
			break ;														// End WM_CREATE

		case WM_COMMAND:
			switch (wm_id) {
				case IDC_BUTTON_COPY: {
					/*
					OLD CODE THAT DID EVERYTHING BY HAND !!! Instead, use the standard
					WM_COPY message !!!

					// Copy the current selection into the clipboard.
					HLOCAL clipboard_data ;
					DWORD selection_start, selection_stop, selection_result ;

					selection_result = SendMessage (result_edit_hd, EM_GETSEL,
						(WPARAM) &selection_start,	(LPARAM) &selection_stop) ;
					if (selection_result ==  -1) return (0) ;

					if (OpenClipboard (NULL)) {
						SendMessage (result_listbox_hd, LB_GETTEXT, (WPARAM) selection_index,
							(LPARAM) tmp_unicode_string) ;
						clipboard_data = (HLOCAL) LocalAlloc (LMEM_FIXED,
							(1 + wcslen (tmp_unicode_string)) * sizeof (TCHAR)) ;
						wcscpy ((TCHAR*) clipboard_data, tmp_unicode_string) ;
						EmptyClipboard () ;
						SetClipboardData (CF_UNICODETEXT, (HANDLE) clipboard_data) ;
						CloseClipboard () ;
						}
					*/
					SendMessage (result_edit_hd, WM_COPY, (WPARAM) 0, (LPARAM) 0) ;
					return (0) ;
					}															// End of local block for ICD_BUTTON_COPY
					break ;												// End of ICD_BUTTON_COPY

				case IDC_BUTTON_PASTE: {
					/*
					OLD CODE THAT DID EVERYTHING BY HAND !!! Instead, use the standard
					WM_PASTE message !!!

					// Paste data from the clipboard into the edit control.
					HANDLE clipboard_data ;

					if (OpenClipboard (NULL)) {
						clipboard_data = GetClipboardData (CF_UNICODETEXT) ;
						if (clipboard_data) {
							wcscpy (tmp_unicode_string, (LPCTSTR) clipboard_data) ;
							SetWindowText (main_edit_hd, tmp_unicode_string) ;
							}
						CloseClipboard () ;
						}
					*/
					SendMessage (main_edit_hd, WM_CLEAR, (WPARAM) 0, (LPARAM) 0) ;
					SendMessage (main_edit_hd, WM_PASTE, (WPARAM) 0, (LPARAM) 0) ;
					return (0) ;
					}															// End of local block for ICD_BUTTON_PASTE
					break ;												// End of ICD_BUTTON_PASTE

				case IDC_BUTTON_EXIST:
					// We don't setup things for a search animation because existence
					// checking is usually VERY fast !
					UserInterfaceOnOff (FALSE) ;
					GetWindowText (main_edit_hd, tmp_unicode_string, MAX_STRINGLEN) ;
					wcstombs ((char*) tmp_char_string, tmp_unicode_string, MAX_STRINGLEN) ;
					SetWindowText (result_frame_hd, TEXT ("Results")) ;
					if (Search (tmp_char_string))
						SetWindowText (result_edit_hd, TEXT ("This word exists")) ;
					else
						SetWindowText (result_edit_hd, TEXT ("This word does not exist")) ;
					UserInterfaceOnOff (TRUE) ;
					return (0) ;
					break ;									// End of IDC_BUTTON_EXIST

				case IDC_BUTTON_SUGGEST: {
					DWORD work_thread_id ;
					HANDLE work_thread_handle = NULL ;
					int first_line_len ;
					DWORD work_thread_exit_code ;

					// We test if there is no other work currently running. Normally, this
					// should never fail because we disable button before launching any new
					// work, and then we re-activatethemonly when the currently running
					// work is done. But it's just in case...
					if (work_thread_handle == NULL) {
						UserInterfaceOnOff (FALSE) ;
						GetWindowText (main_edit_hd, tmp_unicode_string, MAX_STRINGLEN) ;
						wcstombs ((char*) tmp_char_string, tmp_unicode_string, MAX_STRINGLEN) ;
						SetWindowText (result_edit_hd, TEXT("")) ;
						work_thread_handle = CreateThread (NULL, 0, SuggestThreadProc, (LPVOID) tmp_char_string, 0, &work_thread_id) ;
						StartSearchAnim () ;
						// Check if the search terminated by itself or if it was aborted.
						GetExitCodeThread (work_thread_handle, &work_thread_exit_code) ;
						if (work_thread_exit_code != 0)	TerminateThread (work_thread_handle, -1) ;
							TerminateThread (work_thread_handle, 1) ;
						CloseHandle (work_thread_handle) ;
						DisplaySuggestions () ;
						ReleaseSuggestions () ;
						// Set the current selection of the "edit-listbox" on the first line if it exists.
						first_line_len = (int) SendMessage (result_edit_hd, EM_LINELENGTH, (WPARAM) 0, (LPARAM) 0) ;
						if (first_line_len > 0)
							SendMessage (result_edit_hd, EM_SETSEL, (WPARAM) 0,	(LPARAM) first_line_len) ;
						UserInterfaceOnOff (TRUE) ;
						}												// End of if (work_thread_handle == NULL)
					return (0) ;
					}													// End of local block for IDC_BUTTON_SUGGEST
					break ;										// End of IDC_BUTTON_SUGGEST

				case IDC_BUTTON_CHEAT: {
					DWORD work_thread_id ;
					HANDLE work_thread_handle = NULL ;
					int first_line_len ;
					DWORD work_thread_exit_code ;

					// We test if there is no other work currently running. Normally, this
					// should never fail because we disable button before launching any new
					// work, and then we re-activatethemonly when the currently running
					// work is done. But it's just in case...
					if (work_thread_handle == NULL) {
						UserInterfaceOnOff (FALSE) ;
						GetWindowText (main_edit_hd, tmp_unicode_string, MAX_STRINGLEN) ;
						wcstombs ((char*) tmp_char_string, tmp_unicode_string, MAX_STRINGLEN) ;
						SetWindowText (result_edit_hd, TEXT("")) ;
						work_thread_handle = CreateThread (NULL, 0, CheatThreadProc, (LPVOID) tmp_char_string, 0, &work_thread_id) ;
						StartSearchAnim () ;
						// Check if the search terminated by itself or if it was aborted.
						GetExitCodeThread (work_thread_handle, &work_thread_exit_code) ;
						if (work_thread_exit_code != 0)	TerminateThread (work_thread_handle, 1) ;
						CloseHandle (work_thread_handle) ;
						DisplaySuggestions () ;
						ReleaseSuggestions () ;
						// Set the current selection of the "edit-listbox" on the first line if it exists.
						first_line_len = (int) SendMessage (result_edit_hd, EM_LINELENGTH, (WPARAM) 0, (LPARAM) 0) ;
						if (first_line_len > 0)
							SendMessage (result_edit_hd, EM_SETSEL, (WPARAM) 0, (LPARAM) first_line_len) ;
						UserInterfaceOnOff (TRUE) ;
						}											// End of if (work_thread_handle == NULL)
					return (0) ;
					}												// End of local block for IDC_BUTTON_CHEAT
					break ;									// End of IDC_BUTTON_CHEAT

				case IDC_BUTTON_CASE:
					case_sensitive = !case_sensitive ;
					return (0) ;
					break ;

				case IDC_BUTTON_OPENDIC: {
					OPENFILENAME of;
					const LPTSTR open_filter = TEXT ("Dictionaries (*.bin)\0*.bin\0All Documents (*.*)\0*.*\0\0") ;

					memset (&of, 0, sizeof (of)) ;
					of.lStructSize = sizeof (of) ;
					of.hwndOwner = NULL ;
					of.lpstrFile = tmp_unicode_string ;
					of.nMaxFile = 256 ;
					of.lpstrFilter = open_filter ;
					of.Flags = OFN_FILEMUSTEXIST|OFN_PATHMUSTEXIST ;

					if (GetOpenFileName (&of)) {
						if (!CheckValidDictionary (tmp_unicode_string)) {
							MessageBox (w_handle, TEXT ("Unable to load this file as a valid dictionary. Current dictionary remains unchanged."), TEXT ("Error"),
								MB_SETFOREGROUND|MB_OK|MB_ICONERROR|MB_APPLMODAL) ;
							}												// End of if (!CheckValidDictionary
						else {
							UnloadDictionary () ;
							wcscpy (dic_name, tmp_unicode_string) ;
							if (!LoadDictionary (dic_name)) {
								wcscpy (dic_name, TEXT ("\0")) ;
								MessageBox (w_handle, TEXT ("Unable to load the dictionary."), TEXT ("Error"),
									MB_SETFOREGROUND|MB_OK|MB_ICONERROR|MB_APPLMODAL) ;
								}										// End of if (!LoadDictionary
							SetWindowText (status_static_hd, dic_name) ;
							}											// End of else of if (!CheckValidDictionary
						}												// End of if (GetOpenFileName (&of))
					}													// End of local block for IDC_BUTTON_OPENDIC
					return (0) ;
					break ;										// End of IDC_BUTTON_OPENDIC
				}														// End of switch (wm_id)
			break ;												// End of WM_COMMAND

		case WM_HELP:
			CreateProcess (TEXT("peghelp"), TEXT("IDic.htm"), NULL, NULL,
				FALSE, 0, NULL, NULL, NULL, NULL) ;
			return (0) ;
			break ;											// End of WM_HELP

		case WM_CLOSE:
			// Just triggers a WM_QUIT message that will cause us to exit the mainloop.
			PostQuitMessage (0) ;
			return (0) ;
			break ;									// End of WM_CLOSE
		}													// End for switch (message)
		
	// Remember, window handler must call DefWindowProc to handle
	// the remaining messages. Returning TRUE or FALSE is only the protocol
	// for dialog handlers !
	return (DefWindowProc (w_handle, message, w_param, l_param)) ;
}




int WINAPI WinMain (HINSTANCE i_handle, HINSTANCE prev_i_handle,
		    LPTSTR cmd_line, int w_aspect)
{
	MSG msg ;
	WNDCLASS wc ;
	HWND w_handle ;
	SIPINFO si ;
	int iDelta ;

	// Initialize the global variable containing the class name of the window
	LoadString (i_handle, IDS_W_CLASS_NAME, w_class_name, MAX_STRINGLEN) ;
	app_instance_handle = i_handle ;

	// Check if the program is already running. If yes then focus on the window
	w_handle = FindWindow (w_class_name, NULL) ;
	if (w_handle) {
		SetForegroundWindow (w_handle) ;
		return (0) ;
	}

  LoadPrefs () ;

	// Register the window.
	if (! prev_i_handle) {
		wc.style = CS_HREDRAW|CS_VREDRAW ;
		wc.lpfnWndProc = (WNDPROC) MainWindowHandler ;
		wc.cbClsExtra = 0 ;
    wc.cbWndExtra = 0 ;
    wc.hIcon = (HICON) LoadIcon (app_instance_handle, MAKEINTRESOURCE (IDI_ICON_IDIC)) ;
    wc.hInstance = i_handle ;
    wc.hCursor = NULL ;
    wc.hbrBackground = (HBRUSH) GetStockObject (WHITE_BRUSH) ;
    wc.lpszMenuName = NULL ;
    wc.lpszClassName = w_class_name ;
    RegisterClass (&wc) ;
  }

	// Loads the DLL associated with common controls.
	InitCommonControls () ;

	  // Create the window. Consider the menu at the bottom and the SIP
	si.cbSize = sizeof (si) ;
	SHSipInfo (SPI_GETSIPINFO, 0, &si, 0) ;
	iDelta = (si.fdwFlags & SIPF_ON) ? 0 : MENU_HEIGHT ;
  // Create the window
  w_handle = CreateWindow (w_class_name, TEXT ("IDic 1.2"),
			   WS_VISIBLE, CW_USEDEFAULT, CW_USEDEFAULT,
				 si.rcVisibleDesktop.right - si.rcVisibleDesktop.left,
				 si.rcVisibleDesktop.bottom - si.rcVisibleDesktop.top - iDelta,
			   NULL, NULL, i_handle, NULL) ;
	main_window_hd = w_handle ;

	// Finally display the main window
  ShowWindow (w_handle, w_aspect) ;
  UpdateWindow (w_handle) ;

	// Set the status text.
	if ((automaton_size == 0) && (!LoadDictionary (dic_name)))
		SetWindowText (status_static_hd, TEXT ("No loaded dictionary")) ;
	else SetWindowText (status_static_hd, dic_name) ;

	// Initialize the "busy" animation's stuff.
	InitSearchAnim () ;

  // Entering main message loop
  while (GetMessage (&msg, NULL, 0, 0)) {
		if ((main_dialog_hd == NULL) || (!IsDialogMessage (main_dialog_hd, &msg))) {
			TranslateMessage (&msg) ;
			DispatchMessage (&msg) ;
			}										// End of if ((main_dialog_hd == NULL) ||
		}											// End of while (GetMessage (&msg, NULL, 0, 0))

	// Final cleanup.
	ReleaseSearchAnim () ;
	ReleaseSuggestions () ;
	UnloadDictionary () ;
	SavePrefs () ;
  return (msg.wParam) ;
}

