// *** IDic Windows CE ***
// Version 1.2
// Franois PESSAUX June 2001
// This program is freeware.
// Use its sources as you whant provided that you leave this copyright unchanged
// and that you drop a small word telling that I'm the author of these sources.
// Thank's a lot.
//   --Francois

#include "stdafx.h"
#include <string.h>


struct suggestion *suggestions = NULL ;
int number_suggestions = 0 ;



// Note: AddSuggestion MUST copy the string passed in argument !
void AddSuggestion (unsigned char *word, int weight)
{
	struct suggestion *tmp ;

	// This functiom must copy the string passed in argument !
	// First, it searches if the word already exists as a sugggestion.
	// If not, then it add it with the given weight.
	// If yes, then if the given weight is lower than the weight already
	// associated to the suggestion, then we update the weight, otherwise
	// one do nothing.
	tmp = suggestions ;
	while (tmp != NULL) {
		if (strcmp ((char*) tmp->string, (char*) word) == 0) {
			// Just update the weight of the suggestion
			if (weight < tmp->weight) tmp->weight = weight ;
			return ;
		}
		tmp = tmp->next ;
	}

	// If we get here, that's because the word do not exist yet as a suggestion
	tmp = (struct suggestion*) malloc (sizeof (struct suggestion)) ;
	tmp->string = (unsigned char*)
		malloc ((1 + strlen ((char*) word)) * sizeof (unsigned char)) ;
	strcpy ((char*) tmp->string, (char*) word) ;
	tmp->weight = weight ;
	// Insert in head
	tmp->next = suggestions ;
	number_suggestions++ ;
	suggestions = tmp ;
}



void ReleaseSuggestions ()
{
	struct suggestion *tmp0, *tmp1 ;

	tmp0 = suggestions ;
	while (tmp0 != NULL) {
		free (tmp0->string) ;
		tmp1 = tmp0->next ;
		free (tmp0) ;
		tmp0 = tmp1 ;
		}
	suggestions = NULL ;
	number_suggestions = 0 ;
}




void DisplaySuggestions ()
{
	struct suggestion *tmp ;
	struct suggestion **sugg_table ;
	int inserted_count = 0 ;
	int i, j ;
	int space_needed = 0 ;
	TCHAR *all_suggestions_buffer ;

	// First, display the number of suggestions.
	wsprintf (tmp_unicode_string, TEXT ("Results (%d)"), number_suggestions) ;
	SetWindowText (result_frame_hd, tmp_unicode_string) ;

	// Directly skip everything os no suggestion, so that's it...
	if (suggestions == NULL) return ;

	sugg_table =
		(struct suggestion**) malloc (number_suggestions * sizeof (struct suggestion*)) ;

	tmp = suggestions ;
	while (tmp != NULL) {
		// Insert the string of this suggestion in the table, sorted first by
		// error weight, then alphabetically.
		// First, sort by increasing weight and stop as soon as we found
		// a suggestion with a weight equal or greater.
		for (i = 0; i<inserted_count; i++) {
			if (sugg_table[i]->weight >= tmp->weight) break ;
		}
		// Then, sort alphabetically amongst suggestions with this weight.
		for (;i<inserted_count; i++) {
			if ((sugg_table[i]->weight > tmp->weight)
				  || (strcmp ((char*) sugg_table[i]->string, (char*) tmp->string) >= 0))
				break ;
		}
		// Here, i equals the index where to insert the new suggestion.
		// Everything beyond must be shifted one case farther.
		for (j=inserted_count-1; j>=i; j--) sugg_table[j+1] = sugg_table[j] ;
		sugg_table[i] = tmp ;
		tmp = tmp->next ;
		inserted_count++ ;
		// Add 2 for the "r\n".
		space_needed += 2 + strlen ((char *) sugg_table[i]->string) ;
		}

	// Assertion test. Must always held ! Indeed, just some debug
	if (number_suggestions != inserted_count)
		MessageBox (NULL, TEXT ("number_suggestions != inserted_count"),
			TEXT ("Error - Please report"), MB_SETFOREGROUND|MB_OK|MB_ICONERROR|MB_APPLMODAL) ;

	// Allocate the big text buffer to contain all the suggestions.
	all_suggestions_buffer = (TCHAR*) malloc ((1 + space_needed) * sizeof (TCHAR)) ;
	j = 0 ;
	// Then insert the sorted strings contained in the table in this buffer.
	for (i=0; i< number_suggestions; i++) {
		wsprintf (&all_suggestions_buffer[j], TEXT ("%S\r\n"), (char*) sugg_table[i]->string) ;
		// Add 2 for the "r\n".
		j = 2 + j + strlen ((char*) sugg_table[i]->string) ;
		}

	// Finally insert the big text in the "edit-listbox".
	SendMessage (result_edit_hd, EM_SETLIMITTEXT, (WPARAM) (1 + space_needed), (LPARAM) 0) ;
	SetWindowText (result_edit_hd, all_suggestions_buffer) ;

	// Release the memory and the whole suggestions big text buffer.
	// We don't release the global suggestion here to avoid a partial desallocation
	// in case where this thread is kill prematurately.
	free (sugg_table) ;
	free (all_suggestions_buffer) ;
}
