// *** IDic Windows CE ***
// Version 1.2
// Franois PESSAUX June 2001
// This program is freeware.
// Use its sources as you whant provided that you leave this copyright unchanged
// and that you drop a small word telling that I'm the author of these sources.
// Thank's a lot.
//   --Francois

#include "stdafx.h"
#include <string.h>


enum operation { Nop, Suppr, Add, Wrong } ;

int num_allowed_errors ;
unsigned char sugg_word[MAX_STRINGLEN] ;
int len_wword ;
unsigned char *wrong_word ;




void Permutations ()
{
	int i ;
	unsigned char *word2, tmp ;

	word2 = (unsigned char*) malloc ((len_wword + 1) * sizeof (unsigned char)) ;
	for (i=0; i<len_wword - 1; i++) {
		strcpy ((char*) word2, (char*) wrong_word) ;
    tmp = word2[i] ;
    word2[i] = word2[i+1] ;
    word2[i+1] = tmp ;
		// Note: AddSuggestion MUST copy the string passed in argument !
    if (Search (word2))	AddSuggestion (word2, 1) ;
	}
	free (word2) ;
}



void RecSuggest (unsigned long base, operation last_op, int index_wword,
								 int sugg_word_index, BOOL was_final, int err_cnt)
{
	int real_err_cnt ;
	unsigned char good_letter_code ;
	unsigned int letter_code ;
	DAGElement new_bucket ;
	unsigned long new_base ;
	BOOL is_final ;

	if (err_cnt <= num_allowed_errors) {
		if ((base == END_TRANSITION) || (was_final)) {
		// Le nombre rel d'erreur doit prendre en compte la diffrence de
		// longueur entre la mot d'origine et l'endroit o on en est dedans.
		// S'il, par rapport  cet endroit, il reste encore 2 lettres dans le
    // mot d'origine, a correspond en fait  une suggestion trouve
		// avec 2 oublis en plus des erreurs dj accumules. Attention,
		// l'index courant rfre  une lettre qu'on n'a pas encore traite,
		// donc le nombre d'erreurs rel est :
    //      (len_wword - 1 - index_wword + err_cnt) + 1
    // On abbrge un peu en virant - 1 + 1.
			real_err_cnt = len_wword - index_wword + err_cnt ;
			if (real_err_cnt <= num_allowed_errors) {
				sugg_word[sugg_word_index] = '\0' ;
				// Note: AddSuggestion MUST copy the string passed in argument !
				AddSuggestion (sugg_word, real_err_cnt) ;
			}
		}
		
		if (base != END_TRANSITION) {
			if (index_wword < len_wword) {
				// Considrons que la lettre courante est correcte et
        // que la lettre courante est fausse (factorisation).
				good_letter_code = (unsigned int) wrong_word[index_wword] ;
				for (letter_code = 1; letter_code <= 255; letter_code++) {
					if (((base + letter_code) < automaton_size) &&
						  ((unsigned int) GETCHAR (automaton[base + letter_code]) == letter_code)) {
						// Partage de sous-expression commune
						new_bucket = automaton[base + letter_code] ;
						new_base = GETNEXTBASE (new_bucket) ;
						is_final = GETISFINAL (new_bucket) ;
						// On change juste le poids et la dernire opration
						// effectue en fonction de si on est dans le cas o
						// la lettre est correcte ou fausse et fonction de si on
						// prend la casse en compte ou non.
						sugg_word[sugg_word_index] = (unsigned char) letter_code ;
						if ((letter_code == ((unsigned int) good_letter_code)) ||
								((!case_sensitive) &&
								 (tolower (letter_code) == tolower (good_letter_code))))
							RecSuggest (new_base, Nop, (index_wword + 1),
	                   (sugg_word_index + 1), is_final, err_cnt) ;
						else
							RecSuggest (new_base, Wrong, (index_wword + 1),
	                   (sugg_word_index + 1), is_final, (err_cnt + 1)) ;
					}
				}
				
				// Considrons qu'il y a une lettre en trop dans le mot
				if (last_op != Add)
					RecSuggest (base, Suppr, (index_wword + 1), sugg_word_index,
									FALSE, (err_cnt + 1)) ;

        // Considrons qu'il manque une lettre dans le mot.
				if (last_op != Suppr) {
					for (letter_code = 1; letter_code <= 255; letter_code++) {
						if (((base + letter_code) < automaton_size) &&
							  ((unsigned int) GETCHAR (automaton[base + letter_code]) == letter_code)) {
							// Partage de sous-expression commune
							new_bucket = automaton[base + letter_code] ;
							new_base = GETNEXTBASE (new_bucket) ;
							is_final = GETISFINAL (new_bucket) ;
							sugg_word[sugg_word_index] = (unsigned char) letter_code ;
							RecSuggest (new_base, Add, index_wword, (sugg_word_index + 1),
								is_final, (err_cnt + 1)) ;
						}
					}
				}
			}
		}
	}
}



void Suggest (unsigned char *word)
{
	// Make some stuff global to save memory on the stack during recursion
  len_wword = strlen ((char*) word) ;
	wrong_word = word ;
  if (len_wword >= 7) num_allowed_errors = 2 ;
	else num_allowed_errors = 1 ;
  // Permutations () ;
	RecSuggest (initial_state, Nop, 0, 0, FALSE, 0) ;
}




DWORD WINAPI SuggestThreadProc (LPVOID word)
{
	Suggest ((unsigned char *) word) ;
	// Send the termination custom message WITHOUT without waiting the main
	// Window handler has finished treating it, so that we will terminate
	// immediately.
	StopSearchAnim () ;
	ExitThread (0) ;
	return (0) ;
}

